#!/usr/bin/php
<?php

/*  PEL: PHP Exif Library.  A library with support for reading and
 *  writing all Exif headers in JPEG and TIFF images using PHP.
 *
 *  Copyright (C) 2004, 2005, 2006  Martin Geisler.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program in the file COPYING; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
 *  Boston, MA 02110-1301 USA
 */

/* $Id: dump-image.php 413 2006-01-15 10:27:21Z mgeisler $ */

error_reporting(E_ALL);

/* Make PEL speak the users language, if it is available. */
setlocale(LC_ALL, '');

require_once(dirname(__FILE__) . '/pel/PelDataWindow.php');
require_once(dirname(__FILE__) . '/pel/PelJpeg.php');
require_once(dirname(__FILE__) . '/pel/PelTiff.php');

$prog = array_shift($argv);
$file = '';

while (!empty($argv)) {
  switch ($argv[0]) {
  case '-d':
    Pel::setDebug(true);
    break;
  case '-s':
    Pel::setStrictParsing(true);
    break;
  default:
    $file = $argv[0];
    break;
  }
  array_shift($argv);
}

if (empty($file)) {
  printf("Usage: %s [-d] [-s] <filename>\n", $prog);
  print("Optional arguments:\n");
  print("  -d        turn debug output on.\n");
  print("  -s        turn strict parsing on (halt on errors).\n");
  print("Mandatory arguments:\n");
  print("  filename  a JPEG or TIFF image.\n");
  exit(1);
}

if (!is_readable($file)) {
  printf("Unable to read %s!\n", $file);
  exit(1);
}

/* We typically need lots of RAM to parse TIFF images since they tend
 * to be big and uncompressed. */
ini_set('memory_limit', '600M');

$data = file_get_contents($file);

//$data = 'Exif sdhserh Exif 34\r\000 3444ExifExifExifert ';
// preg_match_all("/Exif/", $data, $out, PREG_OFFSET_CAPTURE);
//!!FIXME!! . - bad regexp (except new line)
 preg_match_all("/\\xFF\\xE1[\\x00-\\xFF]{2}Exif\\x00\\x00/", $data, $out, PREG_OFFSET_CAPTURE);

	$xml = new SimpleXMLElement("<?xml version='1.0'?><kml/>");
   	$xml->addAttribute ('xmlns',"http://earth.google.com/kml/2.2");
	$xml->addChild ('Folder');
//	$xml->addChild ('Placemark');
//print_r($out);
//	$i=0;
    foreach( $out[0] as $str )
    {
//		echo $out[0][$i][1];
//		echo ' ';
//		$i=$i+1;
//	  	echo $str[1] ;	//	Exif offset
//		$data = new PelDataWindow(file_get_contents($file, $offset=$str[1]+2 , $maxlen=65535));
		$data = new PelDataWindow(file_get_contents($file, FALSE, NULL, $str[1]+2, 65535));
//		$data->setByteOrder('BIG_ENDIAN');

        //$len = $data->getShort(0) - 2;
        $len = $data->getByte(0)*256;
        $len = $len + $data->getShort(1) - 2;
        $data->setWindowStart(2);

        $pexif = new PelExif();
        $pexif->load($data->getClone(0, $len));
		
		$gps = $pexif->getTiff()->GetIfd()->getSubIfd(PelIfd::GPS)->getEntries();
		{
			$val     = $gps[PelTag::GPS_LATITUDE]->getValue();
			$degrees = $val[0][0]/$val[0][1];
      		$minutes = $val[1][0]/$val[1][1];
      		$seconds = $val[2][0]/$val[2][1];
			$exif['GPSLatitude'] = ($gps[PelTag::GPS_LATITUDE_REF]->getValue() == 'N' ? '+':'-') . number_format($degrees + $minutes/60 + $seconds/3600,8,'.','');

			$val     = $gps[PelTag::GPS_LONGITUDE]->getValue();
			$degrees = $val[0][0]/$val[0][1];
      		$minutes = $val[1][0]/$val[1][1];
      		$seconds = $val[2][0]/$val[2][1];
			$exif['GPSLongitude'] = ($gps[PelTag::GPS_LONGITUDE_REF]->getValue() == 'W' ? '-':'+') .  number_format($degrees + $minutes/60 + $seconds/3600,8,'.','');

			$val     = $gps[PelTag::GPS_ALTITUDE]->getValue();
			$exif['GPSAltitude'] = number_format($val[0]/$val[1],8,'.','');
			
//			print_r($exif);
		}
//		print_r($gps[PelTag::GPS_LATITUDE]->getValue());
//		print_r($gps[PelTag::GPS_LATITUDE]->getText());

        //KML out
		$xml->Folder->addChild ('Placemark')->addChild ('Point')->addChild ('coordinates', "${exif['GPSLongitude']}, ${exif['GPSLatitude']}, ${exif['GPSAltitude']}" );
//        $xml->Placemark->addChild ('description','Elphel Cam KML');
//        $xml->Placemark->addChild ('name',$exif['GPSDateTime']);
    
//        $xml->Placemark->addChild ('Point');
//        $xml->Placemark->addChild ('Point')->addChild ('coordinates', "${exif['GPSLongitude']}, ${exif['GPSLatitude']}, ${exif['GPSAltitude']}" );
//        $xml->Placemark->Point->addChild ('coordinates', "${exif['GPSLongitude']}, ${exif['GPSLatitude']}, ${exif['GPSAltitude']}" );

/*                                                
        $xml->Placemark->addChild ('Model');
        $xml->Placemark->Model->addChild ('Location');
        $xml->Placemark->Model->Location->addChild ('longitude', $exif['GPSLongitude']);
        $xml->Placemark->Model->Location->addChild ('latitude',  $exif['GPSLatitude']);
        $xml->Placemark->Model->Location->addChild ('altitude',  $exif['GPSAltitude']);
        $xml->Placemark->Model->addChild ('Link');
        $xml->Placemark->Model->Link->addChild ('href','car.dae');
        $xml->Placemark->Model->addChild ('Scale');
        $xml->Placemark->Model->Scale->addChild ('x','0.025');
        $xml->Placemark->Model->Scale->addChild ('y','0.025');
        $xml->Placemark->Model->Scale->addChild ('z','0.025');
        $xml->Placemark->Model->addChild ('Orientation');*/
//        $xml->Placemark->Model->Orientation->addChild ('heading', $exif['CompassDirection']+180);
//        $xml->Placemark->Model->Orientation->addChild ('tilt',    $exif['CompassPitch']);
//        $xml->Placemark->Model->Orientation->addChild ('roll',    $exif['CompassRoll']);
   
     }
//		print_r($xml);
  $rslt=$xml->asXML();
  printf($rslt);

  exit(0);

$data = new PelDataWindow(file_get_contents($file));

if (PelJpeg::isValid($data)) {
  $img = new PelJpeg();
} elseif (PelTiff::isValid($data)) {
  $img = new PelTiff();
} else {
  print("Unrecognized image format! The first 16 bytes follow:\n");
  PelConvert::bytesToDump($data->getBytes(0, 16));
  exit(1);
}


/* Try loading the data. */
$img->load($data);

print($img);

/* Deal with any exceptions: */
if (count(Pel::getExceptions()) > 0) {
  print("\nThe following errors were encountered while loading the image:\n");
  foreach (Pel::getExceptions() as $e)
    print("\n" . $e->__toString());
}

?>